﻿
'ftRoboRemote, Andreas Gail, 2017
'no warrenty, all on your own risk, free of charge
'uses ftrobopy, sharpSsh, Magick.NET, check license information first

Public Class ftRoboRemote

    Public Const MaxConnect As Int16=10 'max. number of RoboTXTs to be addressed simultaeously
    shared ssh(ftRoboRemote.MaxConnect) As Tamir.SharpSsh.SshShell
    Shared sftp(ftRoboRemote.MaxConnect) As Tamir.SharpSsh.Sftp 
    public shared RemoteHostname(10) As string

    Shared Function checkPicture(checkPath As string) As String

        checkPicture="checkPicture error"

        Dim fi As new System.IO.FileInfo(checkPath)

        'Debug.Print(fi.Length & " Bytes")

        If fi.Length>100 then
            checkPicture="checkPicture OK"
        End if

    End Function

    Shared Function transferPicture(ComputerNo As Int16, ComputerIP As string, targetPath As string) As String
        
        transferPicture="transferPicture error"

        If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

        Sftp(ComputerNo) = new Tamir.SharpSsh.Sftp(ComputerIP, "ROBOPro", "ROBOPro")
        System.Threading.Thread.Sleep(100)
        sftp(ComputerNo).Connect()
        System.Threading.Thread.Sleep(100)
        sftp(ComputerNo).Get("/opt/knobloch/ftrobopy/PICTURES/txtimg.jpg", targetPath)
        System.Threading.Thread.Sleep(100)
        sftp(ComputerNo).Close()

        transferPicture="transferPicture OK"

    End Function

    shared Function ConnectTXT(ComputerNo As Int16, ComputerIP As string) As string

        Dim stringBuffer As string
        Dim stringPos1 As Int16
        Dim stringPos2 As Int16

        ConnectTXT="ConnectTXT error"

        If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

        ssh(ComputerNo) = New Tamir.SharpSsh.SshShell(ComputerIP, "ROBOPro", "ROBOPro")

        ssh(ComputerNo).Connect()
        System.Threading.Thread.Sleep(1000)
        stringBuffer=ssh(ComputerNo).Expect("Welcome to FT-txt")
        'Debug.Print(stringBuffer)

        ssh(ComputerNo).RedirectToConsole

        ssh(ComputerNo).WriteLine("hostname")
        System.Threading.Thread.Sleep(200)
        stringBuffer=ssh(ComputerNo).Expect("$")
        stringPos1=InStr(stringBuffer,"hostname")
        stringPos2=InStr(stringBuffer,"$")
        RemoteHostname(ComputerNo)=mid(stringBuffer,stringPos1+10,stringPos2-stringPos1-12)
        'Debug.Print(stringBuffer)

        ssh(ComputerNo).WriteLine("bin/python")
        System.Threading.Thread.Sleep(200)
        stringBuffer=ssh(ComputerNo).Expect(">>>")
        'Debug.Print(stringBuffer)

        ssh(ComputerNo).WriteLine("import ftrobopy")
        System.Threading.Thread.Sleep(200)
        stringBuffer=ssh(ComputerNo).Expect(">>>")
        'Debug.Print(stringBuffer)

        'caution: the following two commands must be set without any delay,
        'when there is a delay the connection (socket) will be closed again within 2 seconds
        ssh(ComputerNo).WriteLine("txt = ftrobopy.ftTXT('" & ComputerIP & "', 65000)")
        ssh(ComputerNo).WriteLine("txt.startOnline()")
        System.Threading.Thread.Sleep(1000)
        stringBuffer=ssh(ComputerNo).Expect(">>>")
        'Debug.Print(stringBuffer)

        ConnectTXT="ConnectTXT OK"

    End Function

    shared Function CloseTXT(ComputerNo As Int16) As string

        CloseTXT="CloseTXT error"

        If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

        ssh(ComputerNo).WriteLine("txt.stopOnline()")
        System.Threading.Thread.Sleep(100)
        stringBuffer=ssh(ComputerNo).Expect(">>>")
        'Debug.Print(stringBuffer)

        ssh(ComputerNo).Close()

        CloseTXT="CloseTXT OK"
        ftRoboRemote.RemoteHostname(ComputerNo)="not defined"

    End Function

    Public Class TXT

        Public Const C_OUTPUT As Int16=0    'output (O1-O8) for lights
        Public const C_MOTOR As Int16 =1    'output (M1-M4) for drives
        Public Const C_VOLTAGE As Int16=0   'input as voltage meter
        Public Const C_SWITCH As Int16=1    'input as voltage push button
        Public Const C_RESISTOR As Int16=1  'input as resistance meter e.g. photo sensor
        Public Const C_ULTRASONIC As Int16=3'input as distance meter
        Public Const C_ANALOG As Int16=0    'input is defined as analog
        Public Const C_DIGITAL As Int16=1   'input is defined as digital

        Shared Function startCameraOnline(ComputerNo As Int16) As String

            startCameraOnline="startCameraOnline error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            ssh(ComputerNo).WriteLine("txt.startCameraOnline()")
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")

            'Debug.Print(stringBuffer)
            
            startCameraOnline="startCameraOnline OK"

        End Function

        Shared Function getCameraFrame(ComputerNo As Int16) As String

            getCameraFrame="getCameraFrame error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            For n=1 to 5

                System.Threading.Thread.Sleep(1000)
                ssh(ComputerNo).WriteLine("pic = txt.getCameraFrame()")
                System.Threading.Thread.Sleep(1000)
                stringBuffer=ssh(ComputerNo).Expect(">>>")

                'Debug.Print(stringBuffer)
            
                'when the reply of the RoboTXT has many characters it is very likely that there was an
                'error meassage, in that case with a retry of the getCameraFrame function is performed
                'hopefully with no error again
                If Microsoft.VisualBasic.Strings.Len(stringBuffer) <100 then
                    n=5
                    getCameraFrame="getCameraFrame OK, picture is on RoboTXT /opt/knobloch/ftrobopy/PICTURES/txtimg.jpg"
                Else
                    'Debug.Print("getCameraFrame error retry " & n)
                End If

            Next n

        End Function

        Shared Function stopCameraOnline(ComputerNo As Int16) As String

            stopCameraOnline="stopCameraOnline error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            ssh(ComputerNo).WriteLine("txt.stopCameraOnline()")
            System.Threading.Thread.Sleep(1000)
            stringBuffer=ssh(ComputerNo).Expect(">>>")

            'Debug.Print(stringBuffer)
            
            stopCameraOnline="stopCameraOnline OK"

        End Function

        Public class getCurrentIrResult

            Public Class raw
                public shared field01 As int16
                public shared field02 As int16
                public shared field03 As int16
                public shared field04 As int16
                public shared field05 As int16
                public shared field06 As int16
                public shared field07 As int16
                public shared field08 As int16
                public shared field09 As int16
                public shared field10 As int16
                public shared field11 As int16
                public shared field12 As int16
                public shared field13 As int16
                public shared field14 As int16
                public shared field15 As int16
                public shared field16 As int16
                public shared field17 As int16
                public shared field18 As int16
                public shared field19 As int16
                public shared field20 As int16
                public shared field21 As int16
                public shared field22 As int16
                public shared field23 As int16
                public shared field24 As int16
                public shared field25 As int16
                public shared field26 As int16
            End Class

            public Class processed
                public shared Pdl_00_LH As int16
                public shared Pdl_00_LV As int16
                public shared Pdl_00_RH As int16
                public shared Pdl_00_RV As int16
                public shared Pdl_10_LH As int16
                public shared Pdl_10_LV As int16
                public shared Pdl_10_RH As int16
                public shared Pdl_10_RV As int16
                public shared Pdl_01_LH As int16
                public shared Pdl_01_LV As int16
                public shared Pdl_01_RH As int16
                public shared Pdl_01_RV As int16
                public shared Pdl_11_LH As int16
                public shared Pdl_11_LV As int16
                public shared Pdl_11_RH As int16
                public shared Pdl_11_RV As int16
            End Class

        End Class

        Shared Function getCurrentIr(ComputerNo As Int16) As String

            Dim stringPos1 As Int16
            Dim stringPos2 As Int16

            getCurrentIr="getCurrentIr error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            ssh(ComputerNo).WriteLine("txt.getCurrentIr()")
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")

            'write to raw variables
            stringPos1=InStr(stringBuffer,"txt.getCurrentIr()")
            stringPos2=InStr(stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field01=val(mid(stringBuffer,stringPos1+18+3,stringPos2-stringPos1-18-3))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field02=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field03=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field04=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field05=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field06=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field07=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field08=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field09=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field10=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field11=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field12=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field13=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field14=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field15=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field16=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field17=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field18=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field19=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field20=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field21=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field22=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field23=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field24=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,",")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field25=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
            stringPos1=InStr(stringPos2,stringBuffer,",")
            stringPos2=InStr(stringPos1+1,stringBuffer,">>>")
            ftRoboRemote.TXT.getCurrentIrResult.raw.field26=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-5))

            'set to 0
            ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_00_LH=0
            ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_00_LV=0
            ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_00_RH=0
            ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_00_RV=0
            ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_10_LH=0
            ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_10_LV=0
            ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_10_RH=0
            ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_10_RV=0
            ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_01_LH=0
            ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_01_LV=0
            ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_01_RH=0
            ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_01_RV=0
            ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_11_LH=0
            ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_11_LV=0
            ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_11_RH=0
            ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_11_RV=0

            'write to processed variables
            'DIP setting 0-0
            If ftRoboRemote.TXT.getCurrentIrResult.raw.field05=0 and ftRoboRemote.TXT.getCurrentIrResult.raw.field10=0 then
                If ftRoboRemote.TXT.getCurrentIrResult.raw.field01=ftRoboRemote.TXT.getCurrentIrResult.raw.field06 then
                    ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_00_LH=ftRoboRemote.TXT.getCurrentIrResult.raw.field01
                End If
                If ftRoboRemote.TXT.getCurrentIrResult.raw.field02=ftRoboRemote.TXT.getCurrentIrResult.raw.field07 then
                    ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_00_LV=ftRoboRemote.TXT.getCurrentIrResult.raw.field02
                End If
                If ftRoboRemote.TXT.getCurrentIrResult.raw.field03=ftRoboRemote.TXT.getCurrentIrResult.raw.field08 then
                    ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_00_RH=ftRoboRemote.TXT.getCurrentIrResult.raw.field03
                End If
                If ftRoboRemote.TXT.getCurrentIrResult.raw.field04=ftRoboRemote.TXT.getCurrentIrResult.raw.field09 then
                    ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_00_RV=ftRoboRemote.TXT.getCurrentIrResult.raw.field04
                End If
            End If
            'DIP setting 1-0
            If ftRoboRemote.TXT.getCurrentIrResult.raw.field05=4 and ftRoboRemote.TXT.getCurrentIrResult.raw.field15=4 then
                If ftRoboRemote.TXT.getCurrentIrResult.raw.field01=ftRoboRemote.TXT.getCurrentIrResult.raw.field11 then
                    ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_10_LH=ftRoboRemote.TXT.getCurrentIrResult.raw.field01
                End If
                If ftRoboRemote.TXT.getCurrentIrResult.raw.field02=ftRoboRemote.TXT.getCurrentIrResult.raw.field12 then
                    ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_10_LV=ftRoboRemote.TXT.getCurrentIrResult.raw.field02
                End If
                If ftRoboRemote.TXT.getCurrentIrResult.raw.field03=ftRoboRemote.TXT.getCurrentIrResult.raw.field13 then
                    ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_10_RH=ftRoboRemote.TXT.getCurrentIrResult.raw.field03
                End If
                If ftRoboRemote.TXT.getCurrentIrResult.raw.field04=ftRoboRemote.TXT.getCurrentIrResult.raw.field14 then
                    ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_10_RV=ftRoboRemote.TXT.getCurrentIrResult.raw.field04
                End If
            End If
            'DIP setting 0-1
            If ftRoboRemote.TXT.getCurrentIrResult.raw.field05=8 and ftRoboRemote.TXT.getCurrentIrResult.raw.field20=8 then
                If ftRoboRemote.TXT.getCurrentIrResult.raw.field01=ftRoboRemote.TXT.getCurrentIrResult.raw.field16 then
                    ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_01_LH=ftRoboRemote.TXT.getCurrentIrResult.raw.field01
                End If
                If ftRoboRemote.TXT.getCurrentIrResult.raw.field02=ftRoboRemote.TXT.getCurrentIrResult.raw.field17 then
                    ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_01_LV=ftRoboRemote.TXT.getCurrentIrResult.raw.field02
                End If
                If ftRoboRemote.TXT.getCurrentIrResult.raw.field03=ftRoboRemote.TXT.getCurrentIrResult.raw.field18 then
                    ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_01_RH=ftRoboRemote.TXT.getCurrentIrResult.raw.field03
                End If
                If ftRoboRemote.TXT.getCurrentIrResult.raw.field04=ftRoboRemote.TXT.getCurrentIrResult.raw.field19 then
                    ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_01_RV=ftRoboRemote.TXT.getCurrentIrResult.raw.field04
                End If
            End If
            'DIP setting 1-1
            If ftRoboRemote.TXT.getCurrentIrResult.raw.field05=12 and ftRoboRemote.TXT.getCurrentIrResult.raw.field25=12 then
                If ftRoboRemote.TXT.getCurrentIrResult.raw.field01=ftRoboRemote.TXT.getCurrentIrResult.raw.field21 then
                    ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_11_LH=ftRoboRemote.TXT.getCurrentIrResult.raw.field01
                End If
                If ftRoboRemote.TXT.getCurrentIrResult.raw.field02=ftRoboRemote.TXT.getCurrentIrResult.raw.field22 then
                    ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_11_LV=ftRoboRemote.TXT.getCurrentIrResult.raw.field02
                End If
                If ftRoboRemote.TXT.getCurrentIrResult.raw.field03=ftRoboRemote.TXT.getCurrentIrResult.raw.field23 then
                    ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_11_RH=ftRoboRemote.TXT.getCurrentIrResult.raw.field03
                End If
                If ftRoboRemote.TXT.getCurrentIrResult.raw.field04=ftRoboRemote.TXT.getCurrentIrResult.raw.field24 then
                    ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_11_RV=ftRoboRemote.TXT.getCurrentIrResult.raw.field04
                End If
            End If

            getCurrentIr="getCurrentIr OK, results are in getCurrentIrResult"

            'Debug.Print(stringBuffer)

        End Function

        Shared Function setMotorSyncMaster(ComputerNo As Int16, slaveMotorID As Int16, masterMotorID As int16) As String

            Dim stringBuffer As string
            Dim stringInput As string

            setMotorSyncMaster="setMotorSyncMaster error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            If slaveMotorID<1 then slaveMotorID=1
            If slaveMotorID>4 then slaveMotorID=4
            If masterMotorID<0 then masterMotorID=0
            If masterMotorID>4 then masterMotorID=4

            slaveMotorID=slaveMotorID-1

            stringInput="txt.setMotorSyncMaster(" & slaveMotorID & ", " & masterMotorID & ")"
            ssh(ComputerNo).WriteLine(stringInput)
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")
            'Debug.Print(stringBuffer)

            setMotorSyncMaster="setMotorSyncMaster OK"

        End Function

        Shared Function incrMotorCmdId(ComputerNo As Int16, motor As Int16) As string

            Dim stringBuffer As string
            Dim stringInput As string

            incrMotorCmdId="incrMotorCmdId error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            If motor<1 then InputID=1
            If motor>4 then InputID=4

            motor=motor-1

            stringInput="txt.incrMotorCmdId(" & motor & ")"
            ssh(ComputerNo).WriteLine(stringInput)
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")
            'Debug.Print(stringBuffer)

            incrMotorCmdId="incrMotorCmdId OK"

        End Function

        Shared function setMotorDistance(ComputerNo As Int16, motor as Int16, encoderSteps As Int16) as string

            Dim stringBuffer As string
            Dim stringInput As string

            setMotorDistance="setMotorDistance error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            If motor<1 then InputID=1
            If motor>4 then InputID=4
            If encoderSteps<0 then encoderSteps=0
            If encoderSteps>32767 then encoderSteps=32767

            motor=motor-1

            stringInput="txt.setMotorDistance(" & motor & ", " & encoderSteps & ")"
            ssh(ComputerNo).WriteLine(stringInput)
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")
            'Debug.Print(stringBuffer)

            setMotorDistance="setMotorDistance OK"

        end function

        Shared Function getHost(ComputerNo As Int16) As String

            Dim stringPos1 As Int16
            Dim stringPos2 As Int16

            getHost="getHost error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            ssh(ComputerNo).WriteLine("txt.getHost()")
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")

            stringPos1=InStr(stringBuffer,"txt.getHost()")
            stringPos2=InStr(stringBuffer,">>>")
            getHost=mid(stringBuffer,stringPos1+16,stringPos2-stringPos1-19)

            'Debug.Print(stringBuffer)

        End Function

        Shared Function incrCounterCmdId(ComputerNo As Int16, InputID As int16) As String

            Dim stringBuffer As string
            Dim stringInput As string

            incrCounterCmdId="incrCounterCmdId error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            If InputID<1 then InputID=1
            If InputID>4 then InputID=4

            InputID=InputID-1

            stringInput="txt.incrCounterCmdId(" & InputID & ")"
            ssh(ComputerNo).WriteLine(stringInput)
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")
            'Debug.Print(stringBuffer)

            incrCounterCmdId="incrCounterCmdId OK"

        End Function

        Public class getCurrentCounterValueResult
            public shared Counter1 As int16
            public shared Counter2 As int16
            public shared Counter3 As int16
            public shared Counter4 As int16
        End Class

        Shared Function getCurrentCounterValue(ComputerNo As Int16, InputID as int16) As String

            Dim stringBuffer As string
            Dim stringInput As string
            Dim stringPos1 As Int16
            Dim stringPos2 As Int16

            getCurrentCounterValue="getCurrentCounterValue error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            If InputID<0 then InputID=0
            If InputID>4 then InputID=4
            InputID=InputID-1

            If InputID=-1 then
                stringInput="txt.getCurrentCounterValue()"
            else
                stringInput="txt.getCurrentCounterValue(" & InputID & ")"
            End if

            ssh(ComputerNo).WriteLine(stringInput)
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect("getCurrentCounterValue")

            If InputID=-1 then
                getCurrentCounterValue="getCurrentCounterValue OK, results are in getCurrentCounterValueResult"
                stringPos1=InStr(stringBuffer,"txt.getCurrentCounterValue()")
                stringPos2=InStr(stringBuffer,",")
                ftRoboRemote.TXT.getCurrentCounterValueResult.Counter1=Val(mid(stringBuffer,stringPos1+Len(stringInput)+3,stringPos2-stringPos1-Len(stringInput)-3))
                stringPos1=InStr(stringPos2,stringBuffer,",")
                stringPos2=InStr(stringPos1+1,stringBuffer,",")
                ftRoboRemote.TXT.getCurrentCounterValueResult.Counter2=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
                stringPos1=InStr(stringPos2,stringBuffer,",")
                stringPos2=InStr(stringPos1+1,stringBuffer,",")
                ftRoboRemote.TXT.getCurrentCounterValueResult.Counter3=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
                stringPos1=InStr(stringPos2,stringBuffer,",")
                stringPos2=InStr(stringPos1+1,stringBuffer,">>>")
                ftRoboRemote.TXT.getCurrentCounterValueResult.Counter4=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-5))
            Else
                stringPos1=InStr(stringBuffer,stringInput)
                stringPos2=InStr(stringBuffer,">>>")
                getCurrentCounterValue=mid(stringBuffer,stringPos1+Len(stringInput)+2,stringPos2-stringPos1-Len(stringInput)-4)
            End if

            'Debug.Print(stringBuffer)

        End Function

        Shared Function setSoundRepeat(ComputerNo As Int16, repeat As int16) As String

            Dim stringBuffer As string

            setSoundRepeat="setSoundRepeat error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            ssh(ComputerNo).WriteLine("txt.setSoundRepeat(" & repeat & ")")
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")
            'Debug.Print(stringBuffer)

            setSoundRepeat="setSoundRepeat OK"

        End Function

        Shared Function setSoundIndex(ComputerNo As Int16, SoundNo As int16) As String

            Dim stringBuffer As string

            setSoundIndex="setSoundIndex error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            ssh(ComputerNo).WriteLine("txt.setSoundIndex(" & SoundNo & ")")
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")
            'Debug.Print(stringBuffer)

            setSoundIndex="setSoundIndex OK"

        End Function

        Public class getCurrentInputResult
            public shared In1 As int16
            public shared In2 As int16
            public shared In3 As int16
            public shared In4 As int16
            public shared In5 As int16
            public shared In6 As int16
            public shared In7 As int16
            public shared In8 As int16
        End Class

        Shared Function getCurrentInput(ComputerNo As Int16, InputID as int16) As String

            Dim stringBuffer As string
            Dim stringInput As string
            Dim stringPos1 As Int16
            Dim stringPos2 As Int16

            getCurrentInput="getCurrentInput error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            If InputID<0 then InputID=0
            If InputID>8 then InputID=8
            InputID=InputID-1
            If InputID=-1 then

                stringInput="txt.getCurrentInput()"
            else
                stringInput="txt.getCurrentInput(" & InputID & ")"
            End if

            ssh(ComputerNo).WriteLine(stringInput)
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect("getCurrentInput")

            'Debug.Print(stringBuffer)

            If InputID=-1 then
                getCurrentInput="getCurrentInput OK, results are in getCurrentInputResult"
                stringPos1=InStr(stringBuffer,"txt.getCurrentInput()")
                stringPos2=InStr(stringBuffer,",")
                ftRoboRemote.TXT.getCurrentInputResult.In1=Val(mid(stringBuffer,stringPos1+Len(stringInput)+3,stringPos2-stringPos1-Len(stringInput)-3))
                stringPos1=InStr(stringPos2,stringBuffer,",")
                stringPos2=InStr(stringPos1+1,stringBuffer,",")
                ftRoboRemote.TXT.getCurrentInputResult.In2=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
                stringPos1=InStr(stringPos2,stringBuffer,",")
                stringPos2=InStr(stringPos1+1,stringBuffer,",")
                ftRoboRemote.TXT.getCurrentInputResult.In3=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
                stringPos1=InStr(stringPos2,stringBuffer,",")
                stringPos2=InStr(stringPos1+1,stringBuffer,",")
                ftRoboRemote.TXT.getCurrentInputResult.In4=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
                stringPos1=InStr(stringPos2,stringBuffer,",")
                stringPos2=InStr(stringPos1+1,stringBuffer,",")
                ftRoboRemote.TXT.getCurrentInputResult.In5=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
                stringPos1=InStr(stringPos2,stringBuffer,",")
                stringPos2=InStr(stringPos1+1,stringBuffer,",")
                ftRoboRemote.TXT.getCurrentInputResult.In6=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
                stringPos1=InStr(stringPos2,stringBuffer,",")
                stringPos2=InStr(stringPos1+1,stringBuffer,",")
                ftRoboRemote.TXT.getCurrentInputResult.In7=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-2))
                stringPos1=InStr(stringPos2,stringBuffer,",")
                stringPos2=InStr(stringPos1+1,stringBuffer,">>>")
                ftRoboRemote.TXT.getCurrentInputResult.In8=Val(mid(stringBuffer,stringPos1+2,stringPos2-stringPos1-5))
            else
                stringPos1=InStr(stringBuffer,stringInput)
                stringPos2=InStr(stringBuffer,">>>")
                getCurrentInput=mid(stringBuffer,stringPos1+Len(stringInput)+2,stringPos2-stringPos1-Len(stringInput)-4)
            End if

            'Debug.Print(stringBuffer)

        End Function

        Shared Function stopAll(ComputerNo As Int16) As String

            Dim stringBuffer As string

            stopAll="stopAll error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            ssh(ComputerNo).WriteLine("txt.StopAll()")
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")
            'Debug.Print(stringBuffer)

            stopAll="stopAll OK"

        End Function

        Shared Function incrSoundCmdId(ComputerNo As Int16) As String

            Dim stringBuffer As string

            incrSoundCmdId="incrSoundCmdId error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            ssh(ComputerNo).WriteLine("txt.incrSoundCmdId()")
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")
            'Debug.Print(stringBuffer)

            incrSoundCmdId="incrSoundCmdId OK"

        End Function

        Shared Function getFirmwareVersion(ComputerNo As Int16) As String

            Dim stringBuffer As string
            Dim stringPos1 As Int16
            Dim stringPos2 As Int16

            getFirmwareVersion="getFirmwareVersion error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            ssh(ComputerNo).WriteLine("txt.getFirmwareVersion()")
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")

            stringPos1=InStr(stringBuffer,"txt.getFirmwareVersion()")
            stringPos2=InStr(stringBuffer,">>>")
            getFirmwareVersion=mid(stringBuffer,stringPos1+20+24,stringPos2-stringPos1-23-24)
            'Debug.Print(stringBuffer)

        End Function

        Shared Function getVersionNumber(ComputerNo As Int16) As String

            Dim stringBuffer As string
            Dim stringPos1 As Int16
            Dim stringPos2 As Int16

            getVersionNumber="getVersionNumber error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            ssh(ComputerNo).WriteLine("print(hex(txt.getVersionNumber()))")
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")

            stringPos1=InStr(stringBuffer,"txt.getVersionNumber()))")
            stringPos2=InStr(stringBuffer,">>>")
            getVersionNumber=mid(stringBuffer,stringPos1+2+24,stringPos2-stringPos1-6-24)

        End Function

        Shared Function getDevicename(ComputerNo As Int16) As String

            Dim stringBuffer As string
            Dim stringPos1 As Int16
            Dim stringPos2 As Int16

            getDevicename="getDevicename error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            ssh(ComputerNo).WriteLine("txt.getDevicename()")
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")

            stringPos1=InStr(stringBuffer,"txt.getDevicename()")
            stringPos2=InStr(stringBuffer,">>>")
            getDevicename=mid(stringBuffer,stringPos1+3+20,stringPos2-stringPos1-6-20)

        End Function

        Shared Function queryStatus(ComputerNo As Int16) As String

            Dim stringBuffer As string

            queryStatus="queryStatus error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            ssh(ComputerNo).WriteLine("name, version = txt.queryStatus()")
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")
            'Debug.Print(stringBuffer)

            queryStatus="queryStatus OK"

        End Function

        Shared Function M(ComputerNo As Int16, Motor1 As Int16, Motor2 As Int16, Motor3 As Int16, Motor4 As Int16) As String

            Dim stringBuffer As string

            M="DefineM error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            'ssh.WriteLine("M = [txt.C_MOTOR, txt.C_MOTOR, txt.C_OUTPUT, txt.C_OUTPUT]")
            ssh(ComputerNo).WriteLine("M = [" & Motor1 & ", " & Motor2 & ", " & Motor3 & ", " & Motor4 & "]")
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")
            'Debug.Print(stringBuffer)

            M="DefineM OK"

        End function

        Shared Function I(ComputerNo As Int16, Input1Type As Int16, Input1Mode As Int16, Input2Type As Int16, Input2Mode As Int16, Input3Type As Int16, Input3Mode As Int16, Input4Type As Int16, Input4Mode As Int16, Input5Type As Int16, Input5Mode As Int16, Input6Type As Int16, Input6Mode As Int16, Input7Type As Int16, Input7Mode As Int16, Input8Type As Int16, Input8Mode As Int16) As string

            Dim stringBuffer As string

            I="DefineI error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            'ssh.WriteLine("I = [(txt.C_SWITCH, txt.C_DIGITAL),(txt.C_SWITCH, txt.C_DIGITAL),(txt.C_ULTRASONIC, txt.C_ANALOG),(txt.C_VOLTAGE, txt.C_ANALOG),(txt.C_RESISTOR, txt.C_ANALOG),(txt.C_SWITCH, txt.C_DIGITAL),(txt.C_SWITCH, txt.C_DIGITAL),(txt.C_SWITCH, txt.C_DIGITAL)]")
            ssh(ComputerNo).WriteLine("I = [(" & Input1Type & ", " & Input1Mode & "),(" & Input2Type & ", " & Input2Mode & "),(" & Input3Type & ", " & Input3Mode & "),(" & Input4Type & ", " & Input4Mode & "),(" & Input5Type & ", " & Input5Mode & "),(" & Input6Type & ", " & Input6Mode & "),(" & Input7Type & ", " & Input7Mode & "),(" & Input8Type & ", " & Input8Mode & ")]")
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")
            'Debug.Print(stringBuffer)

            I="DefineI OK"

        End function

        Shared Function setConfig(ComputerNo As Int16) As string

            Dim stringBuffer As string

            setConfig="setConfig error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            ssh(ComputerNo).WriteLine("txt.setConfig(M, I)")
            System.Threading.Thread.Sleep(200)
            stringBuffer=ssh(ComputerNo).Expect(">>>")
            'Debug.Print(stringBuffer)

            setConfig="setConfig OK"

        End function

        Shared Function updateConfig(ComputerNo As Int16) As string

            Dim stringBuffer As string

            updateConfig="updateConfig error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            ssh(ComputerNo).WriteLine("txt.updateConfig()")
            System.Threading.Thread.Sleep(200)
            stringBuffer=ssh(ComputerNo).Expect(">>>")
            'Debug.Print(stringBuffer)

            updateConfig="updateConfig OK"

        End function

        Shared Function setPwm(ComputerNo As Int16, Out As Int16, Value As int16) As string

            Dim stringBuffer As string

            setPwm="setPwm error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            If Out<1 then Out=1
            If Out>8 then Out=8
            If Value<0 then Value=0
            If Value>512 then Value=512
            Out=Out-1

            'ssh.WriteLine("txt.setPwm(0,0)")
            ssh(ComputerNo).WriteLine("txt.setPwm(" & Out & "," & Value & ")")
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")
            'Debug.Print(stringBuffer)

            setPwm="setPwm OK"

        End Function

        Shared Function setPwmRamp(ComputerNo As Int16, Out As Int16, ValueBegin As int16, ValueEnd As int16, Duration As int16) As string

            Dim stringBuffer As string
            Dim Value As int16
            Dim ValueStep As int16
            Dim Steps As int16

            setPwmRamp="setPwmRamp error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            If Out<1 then Out=1
            If Out>8 then Out=8
            Out=Out-1
            If ValueBegin<0 then ValueBegin=0
            If ValueBegin>512 then ValueBegin=512
            If ValueEnd<0 then ValueEnd=0
            If ValueEnd>512 then ValueEnd=512
            If Duration<0 then Duration=0
            If Duration>60 then Duration=60

            Steps=Duration*10
            ValueStep=Int((ValueEnd-ValueBegin)/Steps)

            'Debug.Print("Out=" & Out)
            'Debug.Print("ValueBegin=" & ValueBegin)
            'Debug.Print("ValueEnd=" & ValueEnd)
            'Debug.Print("Duration=" & Duration)
            'Debug.Print("Steps=" & Steps)
            'Debug.Print("ValueStep=" & ValueStep)

            For Value=ValueBegin to ValueEnd Step ValueStep
                'ssh.WriteLine("txt.setPwm(0,0)")
                ssh(ComputerNo).WriteLine("txt.setPwm(" & Out & "," & Value & ")")
                System.Threading.Thread.Sleep(100)
                stringBuffer=ssh(ComputerNo).Expect(">>>")
                'Debug.Print(stringBuffer)
                'Debug.Print(Now & " Value=" & Value)
            Next Value

            ssh(ComputerNo).WriteLine("txt.setPwm(" & Out & "," & ValueEnd & ")")
            System.Threading.Thread.Sleep(100)
            stringBuffer=ssh(ComputerNo).Expect(">>>")
            'Debug.Print(stringBuffer)

            setPwmRamp="setPwmRamp OK"

        End Function

        Shared Function isOnline(ComputerNo As Int16) As string

            Dim stringBuffer As string
            Dim stringPos1 As Int16
            Dim stringPos2 As Int16

            isOnline="error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            ssh(ComputerNo).WriteLine("print(txt.isOnline())")
            System.Threading.Thread.Sleep(200)

            stringBuffer=ssh(ComputerNo).Expect(">>>")
            stringPos1=InStr(stringBuffer,"print(txt.isOnline())")
            stringPos2=InStr(stringPos1+1,stringBuffer,">>>",)

            'Debug.Print(stringBuffer)

            on Error Resume next
            isOnline=mid(stringBuffer,stringPos1+23,stringPos2-stringPos1-25)
            

        End Function

    End Class

    public Class ftrobopy

        shared Function version(ComputerNo As Int16) As string

            on Error goto versionErr  

            Dim stringBuffer As string
            Dim stringPos1 As Int16
            Dim stringPos2 As Int16

            version="error"

            If ComputerNo<1 and ComputerNo>ftRoboRemote.MaxConnect then Exit Function

            ssh(ComputerNo).WriteLine("ftrobopy.version()")
            System.Threading.Thread.Sleep(100)

            stringBuffer=ssh(ComputerNo).Expect("'")
            stringPos1=InStr(stringBuffer,"'")
            stringPos2=InStr(stringPos1+1,stringBuffer,"'")
            version=mid(stringBuffer,stringPos1+1,stringPos2-stringPos1-1)

            Exit function
            versionErr:
                version="error " & Err.Description

        End Function

    End Class

End Class
